//
// ARF - Augmented Reality Framework (ETSI ISG ARF)
//
// Copyright 2022 ETSI
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// Last change: June 2022
//

#ifndef DefaultApiEtsi_H_
#define DefaultApiEtsi_H_



#include <pistache/endpoint.h>
#include <pistache/http.h>
#include <pistache/router.h>
#include <memory>
#include <optional>
#include <DefaultApi.h>

namespace etsi
{

class DefaultApiEtsi : public org::openapitools::server::api::DefaultApi {
public:
    explicit DefaultApiEtsi(const std::shared_ptr<Pistache::Rest::Router>& rtr);
    ~DefaultApiEtsi() override = default;

    void get_version(Pistache::Http::ResponseWriter &response);
    void get_ping(Pistache::Http::ResponseWriter &response);

};

}


#endif
